/**
 * @file main.c
 * @author your name (you@domain.com)
 * @brief
 * @version 0.1
 * @date 2021-05-18
 *
 * @copyright Copyright (c) 2021
 *
 */
/*******************************************************************************
*
* 代码许可和免责信息
* 武汉芯源半导体有限公司授予您使用所有编程代码示例的非专属的版权许可，您可以由此
* 生成根据您的特定需要而定制的相似功能。根据不能被排除的任何法定保证，武汉芯源半
* 导体有限公司及其程序开发商和供应商对程序或技术支持（如果有）不提供任何明示或暗
* 含的保证或条件，包括但不限于暗含的有关适销性、适用于某种特定用途和非侵权的保证
* 或条件。
* 无论何种情形，武汉芯源半导体有限公司及其程序开发商或供应商均不对下列各项负责，
* 即使被告知其发生的可能性时，也是如此：数据的丢失或损坏；直接的、特别的、附带的
* 或间接的损害，或任何后果性经济损害；或利润、业务、收入、商誉或预期可节省金额的
* 损失。
* 某些司法辖区不允许对直接的、附带的或后果性的损害有任何的排除或限制，因此某些或
* 全部上述排除或限制可能并不适用于您。
*
*******************************************************************************/

/******************************************************************************
 * Include files
 ******************************************************************************/
#include "main.h"
#include "cw32l052_autotrim.h"
#include "cw32l052_rcc.h"
#include "cw32l052_gpio.h"
#include "cw32l052_systick.h"

/******************************************************************************
 * Local pre-processor symbols/macros ('#define')
 ******************************************************************************/

/******************************************************************************
 * Global variable definitions (declared in header file with 'extern')
 ******************************************************************************/

/******************************************************************************
 * Local type definitions ('typedef')
 ******************************************************************************/

/******************************************************************************
 * Local function prototypes ('static')
 ******************************************************************************/
void GPIO_Configuration(void);
void NVIC_Configuration(void);

/******************************************************************************
 * Local variable definitions ('static')                                      *
 ******************************************************************************/

/******************************************************************************
 * Local pre-processor symbols/macros ('#define')
 ******************************************************************************/

/*****************************************************************************
 * Function implementation - global ('extern') and local ('static')
 ******************************************************************************/


/**
 ******************************************************************************
 ** \brief  Main function of project
 **
 ** \return uint32_t return value, if needed
 **
 ** This sample toggle PB08、PB09
 **
 ******************************************************************************/
int32_t main(void)
{
    AUTOTRIM_TrimInitTypeDef Trim_InitStruct ={0}; 
    uint32_t TrimValue;    
    
    __RCC_AUTOTRIM_CLK_ENABLE();   // 打开AUTOTRIM的配置时钟
    
    GPIO_Configuration();     
    InitTick(8000000);
    PC10_SETHIGH();    // LED2 ON    
    
    CW_SYSCTRL->HSI_f.TRIM = (*((volatile uint16_t *)0x00100A00U) - 40);    // 人为将HSIOSC的频率拉偏，约44.2MHz   
    RCC_HSI_OUT();    // PB输出HSI用于观测
    SysTickDelay(5000);  //  延时用于观察
    
    RCC_LSE_Enable(RCC_LSE_MODE_OSC,RCC_LSE_AMP_LARGER, RCC_LSE_DRIVER_LARGER);  // 启动LSE，用于校准HSIOSC    
    
	  Trim_InitStruct.TrimAuto = AUTOTRIM_AUTO_ENABLE;
    Trim_InitStruct.TrimClkSource = AUTOTRIM_CLKSOURCE_LSE;
    Trim_InitStruct.TrimClkPrescale = AUTOTRIM_PRS_DIV2;
    Trim_InitStruct.TrimMode = AUTOTRIM_MODE_HSIOSC;
    Trim_InitStruct.TrimType = AUTOTRIM_TRIMTYPE_SINGLE;
    Trim_InitStruct.TrimPeriod = 2929;
    AUTOTRIM_TrimInit(&Trim_InitStruct);  
    AUTOTRIM_Cmd(ENABLE);
    
    while(AUTOTRIM_GetITStatus(AUTOTRIM_IT_END) != SET);
    TrimValue = AUTOTRIM_GetTrimValue();
    AUTOTRIM_HSIOSCTrim(TrimValue);
    

    while(1)
    {
       PC10_TOG();
       SysTickDelay(500);      
    }
}

/**
 * @brief Construct a new trim irqhandlercallback object
 * 
 */


/**
  * @brief  Configure the GPIO Pins.
  * @param  None
  * @retval None
  */
void GPIO_Configuration(void)
{
    GPIO_InitTypeDef GPIO_InitStruct ={0};
    __RCC_GPIOC_CLK_ENABLE();
    __RCC_GPIOA_CLK_ENABLE();

    GPIO_InitStruct.Pins = GPIO_PIN_10;
    GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
    GPIO_Init(CW_GPIOC, &GPIO_InitStruct);

    GPIO_InitStruct.Pins = GPIO_PIN_15;
    GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
    GPIO_Init(CW_GPIOA, &GPIO_InitStruct);

    PC10_SETLOW();
    PA15_SETLOW();
}


/**
  * @brief  Configure the nested vectored interrupt controller.
  * @param  None
  * @retval None
  */
void NVIC_Configuration(void)
{
    //优先级，无优先级分组
    NVIC_SetPriority(AUTOTRIM_LCD_IRQn, 0);
    //UARTx中断使能
    NVIC_EnableIRQ(AUTOTRIM_LCD_IRQn);
}



#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
    /* USER CODE BEGIN 6 */
    /* User can add his own implementation to report the file name and line number,
       tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
    /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

